#ifndef JETBYTE_ASYNC_SERVER_MAILSLOT_INCLUDED_
#define JETBYTE_ASYNC_SERVER_MAILSLOT_INCLUDED_
///////////////////////////////////////////////////////////////////////////////
//
// File           : $Workfile: $
// Version        : $Revision: $
// Function       : 
//
// Author         : $Author: $
// Date           : $Date: $
//
// Notes          : Asynchronous server mailslot COM object.
//
// Modifications  :
//
// $Log: $
// 
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2002 JetByte Limited.
//
// JetByte Limited grants you ("Licensee") a non-exclusive, royalty free, 
// licence to use, modify and redistribute this software in source and binary 
// code form, provided that i) this copyright notice and licence appear on all 
// copies of the software; and ii) Licensee does not utilize the software in a 
// manner which is disparaging to JetByte Limited.
//
// This software is provided "AS IS," without a warranty of any kind. ALL
// EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING 
// ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
// OR NON-INFRINGEMENT, ARE HEREBY EXCLUDED. JETBYTE LIMITED AND ITS LICENSORS 
// SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF 
// USING, MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO 
// EVENT WILL JETBYTE LIMITED BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, 
// OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE 
// DAMAGES, HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING 
// OUT OF THE USE OF OR INABILITY TO USE SOFTWARE, EVEN IF JETBYTE LIMITED 
// HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
//
// This software is not designed or intended for use in on-line control of
// aircraft, air traffic, aircraft navigation or aircraft communications; or in
// the design, construction, operation or maintenance of any nuclear
// facility. Licensee represents and warrants that it will not use or
// redistribute the Software for such purposes.
//
///////////////////////////////////////////////////////////////////////////////

#include "resource.h"       

#include "AsyncCOMMailslot.h"
#include "IServerMailslotInit.h"
#include "JBCOMMailslotCP.h"
#include "IMailslotDataInit.h"
#include "AsyncServerEventHelper.h"

///////////////////////////////////////////////////////////////////////////////
// CAsyncServerMailslot
///////////////////////////////////////////////////////////////////////////////

class ATL_NO_VTABLE CAsyncServerMailslot : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CAsyncServerMailslot, &CLSID_AsyncServerMailslot>,
	public ISupportErrorInfo,
	public IConnectionPointContainerImpl<CAsyncServerMailslot>,
	public IDispatchImpl<IAsyncServerMailslot, &IID_IAsyncServerMailslot, &LIBID_JBCOMMAILSLOTLib>,
   public IServerMailslotInit,
   public CProxy_IAsyncServerMailslotEvents< CAsyncServerMailslot >,
   public _AsyncServerEvent,
   private CAsyncCOMMailslot
{
public:
	CAsyncServerMailslot();
   ~CAsyncServerMailslot();

DECLARE_REGISTRY_RESOURCEID(IDR_ASYNCSERVERMAILSLOT)

BEGIN_COM_MAP(CAsyncServerMailslot)
	COM_INTERFACE_ENTRY(IAsyncServerMailslot)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
   COM_INTERFACE_ENTRY(IServerMailslotInit)
   COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
END_COM_MAP()
BEGIN_CONNECTION_POINT_MAP(CAsyncServerMailslot)
CONNECTION_POINT_ENTRY(DIID__IAsyncServerMailslotEvents)
END_CONNECTION_POINT_MAP()

   // ISupportsErrorInfo
	
   STDMETHOD(InterfaceSupportsErrorInfo)(
      REFIID riid);

   // IAsyncServerMailslot

	STDMETHOD(get_MaxMessageSize)(
      /*[out, retval]*/ long *pVal);

   // IServerMailslotInit

   STDMETHOD(Init)(
      /*[in]*/ BSTR name,
      /*[in]*/ DWORD dwMaxMessageSize,
      /*[in]*/ DWORD dwReadTimeout);

   // _AsyncServerEvent

   STDMETHOD(OnDataRecieved)();

private :

   CAsyncServerEventHelper m_asyncServerEventHelper;

   IMailslotData *m_pIData;
   IMailslotDataInit *m_pIDataInit;
};

#endif // JETBYTE_ASYNC_SERVER_MAILSLOT_INCLUDED_

///////////////////////////////////////////////////////////////////////////////
// End of file...
///////////////////////////////////////////////////////////////////////////////
