#ifndef JETBYTE_COM_MAILSLOT_INCLUDED_
#define JETBYTE_COM_MAILSLOT_INCLUDED_
///////////////////////////////////////////////////////////////////////////////
//
// File           : $Workfile: $
// Version        : $Revision: $
// Function       : 
//
// Author         : $Author: $
// Date           : $Date: $
//
// Notes          : COM wrapper for Win32 Mailslots. We could break out the
//                  server specific stuff so that the client objects dont 
//                  include the excess baggage, but it hardly seems worth it.
//
// Modifications  :
//
// $Log: $
// 
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2002 JetByte Limited.
//
// JetByte Limited grants you ("Licensee") a non-exclusive, royalty free, 
// licence to use, modify and redistribute this software in source and binary 
// code form, provided that i) this copyright notice and licence appear on all 
// copies of the software; and ii) Licensee does not utilize the software in a 
// manner which is disparaging to JetByte Limited.
//
// This software is provided "AS IS," without a warranty of any kind. ALL
// EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING 
// ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
// OR NON-INFRINGEMENT, ARE HEREBY EXCLUDED. JETBYTE LIMITED AND ITS LICENSORS 
// SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF 
// USING, MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO 
// EVENT WILL JETBYTE LIMITED BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, 
// OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE 
// DAMAGES, HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING 
// OUT OF THE USE OF OR INABILITY TO USE SOFTWARE, EVEN IF JETBYTE LIMITED 
// HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
//
// This software is not designed or intended for use in on-line control of
// aircraft, air traffic, aircraft navigation or aircraft communications; or in
// the design, construction, operation or maintenance of any nuclear
// facility. Licensee represents and warrants that it will not use or
// redistribute the Software for such purposes.
//
///////////////////////////////////////////////////////////////////////////////

#include "Utils.h"

///////////////////////////////////////////////////////////////////////////////
// Forward references
///////////////////////////////////////////////////////////////////////////////

class CAsyncCOMMailslot;

///////////////////////////////////////////////////////////////////////////////
// CCOMMailslot
///////////////////////////////////////////////////////////////////////////////

class ATL_NO_VTABLE CCOMMailslot 
{

protected :

   CCOMMailslot(
      const GUID &clsid,
      const IID &iid);
   
   ~CCOMMailslot();

   HRESULT Open(
      LPOLESTR name,
      LPOLESTR computerOrDomain);

   HRESULT Create(
      LPOLESTR name,
      DWORD dwMaxMessageSize,
      DWORD dwReadTimeout);

   bool IsOpen() const;

   HRESULT Write(
      LPCVOID lpBuffer,
      DWORD dwNumberOfBytesToWrite);

   HRESULT Read(
      BYTE **ppData, 
      DWORD &dwDataLength);

   HRESULT SizeOfWaitingMessage(
      long *pVal);

   HRESULT MessageWaiting(
      BOOL *pVal);

   HRESULT MessageCount(
      long *pVal);

   HRESULT MaxMessageSize(
      long *pVal);

   HRESULT ReadTimeout(
      long *pVal);

   HRESULT ReadTimeout(
      long newVal);

   HRESULT ReportError(
      DWORD lastError);

   HRESULT ReportError(
      LPCTSTR pMessage,
      HRESULT hr);

   HRESULT ReportError(
      LPOLESTR pMessage,
      HRESULT hr);

private :

   HRESULT CheckMailslotIsNotOpen();
   HRESULT CheckMailslotIsOpen();

   HRESULT GetBuffer(
      BYTE **ppBuffer,
      DWORD *pdwBufferSize);

   friend class CAsyncCOMMailslot;

   HANDLE m_hMailslot;

   const GUID &m_clsid;
   const IID &m_iid;
   size_t m_maxMessageSize;

   CBuffer m_readBuffer;
};

#endif // JETBYTE_COM_MAILSLOT_INCLUDED_

///////////////////////////////////////////////////////////////////////////////
// End of file
///////////////////////////////////////////////////////////////////////////////
