#ifndef JETBYTE_CLIENT_MAILSLOT_INCLUDED_
#define JETBYTE_CLIENT_MAILSLOT_INCLUDED_
///////////////////////////////////////////////////////////////////////////////
//
// File           : $Workfile: $
// Version        : $Revision: $
// Function       : 
//
// Author         : $Author: $
// Date           : $Date: $
//
// Notes          : Client Mailslot COM object.
//
// Modifications  :
//
// $Log: $
// 
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2002 JetByte Limited.
//
// JetByte Limited grants you ("Licensee") a non-exclusive, royalty free, 
// licence to use, modify and redistribute this software in source and binary 
// code form, provided that i) this copyright notice and licence appear on all 
// copies of the software; and ii) Licensee does not utilize the software in a 
// manner which is disparaging to JetByte Limited.
//
// This software is provided "AS IS," without a warranty of any kind. ALL
// EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING 
// ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
// OR NON-INFRINGEMENT, ARE HEREBY EXCLUDED. JETBYTE LIMITED AND ITS LICENSORS 
// SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF 
// USING, MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO 
// EVENT WILL JETBYTE LIMITED BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, 
// OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE 
// DAMAGES, HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING 
// OUT OF THE USE OF OR INABILITY TO USE SOFTWARE, EVEN IF JETBYTE LIMITED 
// HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
//
// This software is not designed or intended for use in on-line control of
// aircraft, air traffic, aircraft navigation or aircraft communications; or in
// the design, construction, operation or maintenance of any nuclear
// facility. Licensee represents and warrants that it will not use or
// redistribute the Software for such purposes.
//
///////////////////////////////////////////////////////////////////////////////

#include "resource.h"       
#include "COMMailslot.h"
#include "IClientMailslotInit.h"

///////////////////////////////////////////////////////////////////////////////
// CClientMailslot
///////////////////////////////////////////////////////////////////////////////

class ATL_NO_VTABLE CClientMailslot : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CClientMailslot, &CLSID_ClientMailslot>,
	public ISupportErrorInfo,
	public IDispatchImpl<IClientMailslot, &IID_IClientMailslot, &LIBID_JBCOMMAILSLOTLib>,
   public IClientMailslotInit,
   private CCOMMailslot
{
public:

   CClientMailslot();
   
DECLARE_REGISTRY_RESOURCEID(IDR_CLIENTMAILSLOT)

BEGIN_COM_MAP(CClientMailslot)
	COM_INTERFACE_ENTRY(IClientMailslot)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
   COM_INTERFACE_ENTRY(IClientMailslotInit)
END_COM_MAP()

   // ISupportsErrorInfo
	
   STDMETHOD(InterfaceSupportsErrorInfo)(
      REFIID riid);

   // IClientMailslot

   STDMETHOD(Write)(
      /*[in]*/ VARIANT arrayOfBytes);
	
   STDMETHOD(WriteString)(
      /*[in]*/ BSTR data);

   // IClientMailslotInit

   STDMETHOD(Init)(
      /*[in]*/ BSTR name,
      /*[in]*/ VARIANT computerOrDomain);
};

#endif // JETBYTE_CLIENT_MAILSLOT_INCLUDED_

///////////////////////////////////////////////////////////////////////////////
// End of file...
///////////////////////////////////////////////////////////////////////////////
