///////////////////////////////////////////////////////////////////////////////
//
// File           : $Workfile: $
// Version        : $Revision: $
// Function       : 
//
// Author         : $Author: $
// Date           : $Date: $
//
// Notes          : Mailslot Data COM object - for use in the async read event.
//
// Modifications  :
//
// $Log: $
// 
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2002 JetByte Limited.
//
// JetByte Limited grants you ("Licensee") a non-exclusive, royalty free, 
// licence to use, modify and redistribute this software in source and binary 
// code form, provided that i) this copyright notice and licence appear on all 
// copies of the software; and ii) Licensee does not utilize the software in a 
// manner which is disparaging to JetByte Limited.
//
// This software is provided "AS IS," without a warranty of any kind. ALL
// EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING 
// ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
// OR NON-INFRINGEMENT, ARE HEREBY EXCLUDED. JETBYTE LIMITED AND ITS LICENSORS 
// SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF 
// USING, MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO 
// EVENT WILL JETBYTE LIMITED BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, 
// OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE 
// DAMAGES, HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING 
// OUT OF THE USE OF OR INABILITY TO USE SOFTWARE, EVEN IF JETBYTE LIMITED 
// HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
//
// This software is not designed or intended for use in on-line control of
// aircraft, air traffic, aircraft navigation or aircraft communications; or in
// the design, construction, operation or maintenance of any nuclear
// facility. Licensee represents and warrants that it will not use or
// redistribute the Software for such purposes.
//
///////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "JBCOMMailslot.h"
#include "MailslotData.h"

#include "Utils.h"

///////////////////////////////////////////////////////////////////////////////
// CMailslotData
///////////////////////////////////////////////////////////////////////////////

CMailslotData::CMailslotData()
   :  m_pData(0),
      m_length(0)
{

}

STDMETHODIMP CMailslotData::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_IMailslotData
	};
	for (int i=0; i < sizeof(arr) / sizeof(arr[0]); i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}

STDMETHODIMP CMailslotData::get_SizeOfMessage(long *pVal)
{
   if (!pVal)
   {
      return AtlReportError(CLSID_MailslotData, L"pVal is an invalid pointer", IID_IMailslotData, E_POINTER);
   }

   *pVal = m_length;

	return S_OK;
}

STDMETHODIMP CMailslotData::ReadString(BSTR *pResults)
{
   if (!pResults)
   {
      return E_POINTER;
   }

   *pResults = ::SysAllocStringByteLen((char*)m_pData, m_length);

	return S_OK;
}

STDMETHODIMP CMailslotData::Read(VARIANT *ppResults)
{
   if (!ppResults)
   {
      return E_POINTER;
   }

   return CreateSafeArray(m_pData, m_length, ppResults); 
}


HRESULT CMailslotData::Init(unsigned char *pData, size_t length)
{
   m_pData = pData;
   m_length = length;

   return S_OK;
}

///////////////////////////////////////////////////////////////////////////////
// End of file
///////////////////////////////////////////////////////////////////////////////
