#ifndef JETBYTE_MAILSLOT_DATA_INCLUDED_
#define JETBYTE_MAILSLOT_DATA_INCLUDED_
///////////////////////////////////////////////////////////////////////////////
//
// File           : $Workfile: $
// Version        : $Revision: $
// Function       : 
//
// Author         : $Author: $
// Date           : $Date: $
//
// Notes          : Mailslot Data COM object - for use in the async read event.
//
// Modifications  :
//
// $Log: $
// 
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2002 JetByte Limited.
//
// JetByte Limited grants you ("Licensee") a non-exclusive, royalty free, 
// licence to use, modify and redistribute this software in source and binary 
// code form, provided that i) this copyright notice and licence appear on all 
// copies of the software; and ii) Licensee does not utilize the software in a 
// manner which is disparaging to JetByte Limited.
//
// This software is provided "AS IS," without a warranty of any kind. ALL
// EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING 
// ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
// OR NON-INFRINGEMENT, ARE HEREBY EXCLUDED. JETBYTE LIMITED AND ITS LICENSORS 
// SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF 
// USING, MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO 
// EVENT WILL JETBYTE LIMITED BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, 
// OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE 
// DAMAGES, HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING 
// OUT OF THE USE OF OR INABILITY TO USE SOFTWARE, EVEN IF JETBYTE LIMITED 
// HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
//
// This software is not designed or intended for use in on-line control of
// aircraft, air traffic, aircraft navigation or aircraft communications; or in
// the design, construction, operation or maintenance of any nuclear
// facility. Licensee represents and warrants that it will not use or
// redistribute the Software for such purposes.
//
///////////////////////////////////////////////////////////////////////////////

#include "resource.h"  

#include "IMailslotDataInit.h"

///////////////////////////////////////////////////////////////////////////////
// CMailslotData
///////////////////////////////////////////////////////////////////////////////

class ATL_NO_VTABLE CMailslotData : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CMailslotData, &CLSID_MailslotData>,
	public ISupportErrorInfo,
	public IDispatchImpl<IMailslotData, &IID_IMailslotData, &LIBID_JBCOMMAILSLOTLib>,
   public IMailslotDataInit
{
public:
	CMailslotData();

DECLARE_REGISTRY_RESOURCEID(IDR_MAILSLOTDATA)

BEGIN_COM_MAP(CMailslotData)
	COM_INTERFACE_ENTRY(IMailslotData)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
   COM_INTERFACE_ENTRY(IMailslotDataInit)
END_COM_MAP()

   // ISupportsErrorInfo
	
   STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

   // IMailslotData

	STDMETHOD(Read)(
      /*[out, retval]*/ VARIANT *ppResults);

	STDMETHOD(ReadString)(
      /*[out, retval]*/ BSTR *pResults);

	STDMETHOD(get_SizeOfMessage)(
      /*[out, retval]*/ long *pVal);

   // IMailslotDataInit
   STDMETHOD(Init)(
      /*[in]*/ unsigned char *pData, 
      /*[in]*/ size_t length);

private :

   unsigned char *m_pData;
   size_t m_length;
};

#endif // JETBYTE_MAILSLOT_DATA_INCLUDED_

///////////////////////////////////////////////////////////////////////////////
// End of file
///////////////////////////////////////////////////////////////////////////////

