#ifndef JETBYTE_MAILSLOT_FACTORY_INCLUDED_
#define JETBYTE_MAILSLOT_FACTORY_INCLUDED_
///////////////////////////////////////////////////////////////////////////////
//
// File           : $Workfile: $
// Version        : $Revision: $
// Function       : 
//
// Author         : $Author: $
// Date           : $Date: $
//
// Notes          : COM Mailslot object factory.
//
// Modifications  :
//
// $Log: $
// 
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2002 JetByte Limited.
//
// JetByte Limited grants you ("Licensee") a non-exclusive, royalty free, 
// licence to use, modify and redistribute this software in source and binary 
// code form, provided that i) this copyright notice and licence appear on all 
// copies of the software; and ii) Licensee does not utilize the software in a 
// manner which is disparaging to JetByte Limited.
//
// This software is provided "AS IS," without a warranty of any kind. ALL
// EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING 
// ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
// OR NON-INFRINGEMENT, ARE HEREBY EXCLUDED. JETBYTE LIMITED AND ITS LICENSORS 
// SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF 
// USING, MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO 
// EVENT WILL JETBYTE LIMITED BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, 
// OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE 
// DAMAGES, HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING 
// OUT OF THE USE OF OR INABILITY TO USE SOFTWARE, EVEN IF JETBYTE LIMITED 
// HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
//
// This software is not designed or intended for use in on-line control of
// aircraft, air traffic, aircraft navigation or aircraft communications; or in
// the design, construction, operation or maintenance of any nuclear
// facility. Licensee represents and warrants that it will not use or
// redistribute the Software for such purposes.
//
///////////////////////////////////////////////////////////////////////////////

#include "resource.h"       

///////////////////////////////////////////////////////////////////////////////
// CMailslotFactory
///////////////////////////////////////////////////////////////////////////////

class ATL_NO_VTABLE CMailslotFactory : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CMailslotFactory, &CLSID_MailslotFactory>,
	public ISupportErrorInfo,
	public IDispatchImpl<IMailslotFactory, &IID_IMailslotFactory, &LIBID_JBCOMMAILSLOTLib>
{
public:
	CMailslotFactory()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_MAILSLOTFACTORY)

BEGIN_COM_MAP(CMailslotFactory)
	COM_INTERFACE_ENTRY(IMailslotFactory)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()

   // ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

   // IMailslotFactory
	
   STDMETHOD(CreateAsyncServerMailslot)(
      /*[in]*/ BSTR name, 
      /*[in, optional]*/ VARIANT maxMessageSize, 
      /*[out, retval]*/ IAsyncServerMailslot **ppSlot);

	STDMETHOD(CreateServerMailslot)(
      /*[in]*/ BSTR name,
      /*[in, optional]*/ VARIANT maxMessageSize,
      /*[in, optional]*/ VARIANT readTimeOut,
      /*[out, retval]*/ IServerMailslot **ppSlot);

	STDMETHOD(CreateClientMailslot)(
      /*[in]*/ BSTR name, 
      /*[in, optional]*/ VARIANT computerOrDomain, 
      /*[out, retval]*/ IClientMailslot **ppSlot);
};

#endif // JETBYTE_MAILSLOT_FACTORY_INCLUDED_

///////////////////////////////////////////////////////////////////////////////
// End of file
///////////////////////////////////////////////////////////////////////////////
