///////////////////////////////////////////////////////////////////////////////
//
// File           : $Workfile: $
// Version        : $Revision: $
// Function       : 
//
// Author         : $Author: $
// Date           : $Date: $
//
// Notes          : Server Mailslot COM object.
//
// Modifications  :
//
// $Log: $
// 
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2002 JetByte Limited.
//
// JetByte Limited grants you ("Licensee") a non-exclusive, royalty free, 
// licence to use, modify and redistribute this software in source and binary 
// code form, provided that i) this copyright notice and licence appear on all 
// copies of the software; and ii) Licensee does not utilize the software in a 
// manner which is disparaging to JetByte Limited.
//
// This software is provided "AS IS," without a warranty of any kind. ALL
// EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING 
// ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
// OR NON-INFRINGEMENT, ARE HEREBY EXCLUDED. JETBYTE LIMITED AND ITS LICENSORS 
// SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF 
// USING, MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO 
// EVENT WILL JETBYTE LIMITED BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, 
// OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE 
// DAMAGES, HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING 
// OUT OF THE USE OF OR INABILITY TO USE SOFTWARE, EVEN IF JETBYTE LIMITED 
// HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
//
// This software is not designed or intended for use in on-line control of
// aircraft, air traffic, aircraft navigation or aircraft communications; or in
// the design, construction, operation or maintenance of any nuclear
// facility. Licensee represents and warrants that it will not use or
// redistribute the Software for such purposes.
//
///////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"

#include "JBCOMMailslot.h"
#include "ServerMailslot.h"
#include "Utils.h"

///////////////////////////////////////////////////////////////////////////////
// CServerMailslot
///////////////////////////////////////////////////////////////////////////////

CServerMailslot::CServerMailslot()
   :  CCOMMailslot(CLSID_ServerMailslot, IID_IServerMailslot)
{
}
   
STDMETHODIMP CServerMailslot::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_IServerMailslot
	};
	for (int i=0; i < sizeof(arr) / sizeof(arr[0]); i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}

STDMETHODIMP CServerMailslot::get_SizeOfWaitingMessage(long *pVal)
{
   return SizeOfWaitingMessage(pVal);
}

STDMETHODIMP CServerMailslot::get_MessageWaiting(BOOL *pVal)
{
   return MessageWaiting(pVal);
}

STDMETHODIMP CServerMailslot::get_MessageCount(long *pVal)
{
   return MessageCount(pVal);
}

STDMETHODIMP CServerMailslot::get_MaxMessageSize(long *pVal)
{
   return MaxMessageSize(pVal);
}

STDMETHODIMP CServerMailslot::get_ReadTimeout(long *pVal)
{
   return ReadTimeout(pVal);
}

STDMETHODIMP CServerMailslot::put_ReadTimeout(long newVal)
{
   return ReadTimeout(newVal);
}

STDMETHODIMP CServerMailslot::ReadString(BSTR *pResult)
{
   if (!pResult)
   {
      return ReportError(L"pResult is an invalid pointer", E_POINTER);
   }

   BYTE *pData;
   DWORD dwDataLength = 0;

   HRESULT hr = CCOMMailslot::Read(&pData, dwDataLength);

   *pResult = ::SysAllocStringByteLen((char*)pData, dwDataLength);

	return hr;
}

STDMETHODIMP CServerMailslot::Read(VARIANT *ppResults)
{
   if (!ppResults)
   {
      return ReportError(L"ppResults is an invalid pointer", E_POINTER);
   }

   BYTE *pData;
   DWORD dwDataLength = 0;

   HRESULT hr = CCOMMailslot::Read(&pData, dwDataLength);

   if (SUCCEEDED(hr))
   {
      hr = CreateSafeArray(pData, dwDataLength, ppResults);
   }

	return hr;
}

STDMETHODIMP CServerMailslot::Init(
   /*[in]*/ BSTR name,
   /*[in]*/ DWORD dwMaxMessageSize,
   /*[in]*/ DWORD dwReadTimeout)
{
   return Create(name, dwMaxMessageSize, dwReadTimeout);
}

///////////////////////////////////////////////////////////////////////////////
// End of file
///////////////////////////////////////////////////////////////////////////////

