#ifndef JETBYTE_SERVER_MAILSLOT_INCLUDED_
#define JETBYTE_SERVER_MAILSLOT_INCLUDED_
///////////////////////////////////////////////////////////////////////////////
//
// File           : $Workfile: $
// Version        : $Revision: $
// Function       : 
//
// Author         : $Author: $
// Date           : $Date: $
//
// Notes          : Server Mailslot COM object.
//
// Modifications  :
//
// $Log: $
// 
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2002 JetByte Limited.
//
// JetByte Limited grants you ("Licensee") a non-exclusive, royalty free, 
// licence to use, modify and redistribute this software in source and binary 
// code form, provided that i) this copyright notice and licence appear on all 
// copies of the software; and ii) Licensee does not utilize the software in a 
// manner which is disparaging to JetByte Limited.
//
// This software is provided "AS IS," without a warranty of any kind. ALL
// EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING 
// ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
// OR NON-INFRINGEMENT, ARE HEREBY EXCLUDED. JETBYTE LIMITED AND ITS LICENSORS 
// SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF 
// USING, MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO 
// EVENT WILL JETBYTE LIMITED BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, 
// OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE 
// DAMAGES, HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING 
// OUT OF THE USE OF OR INABILITY TO USE SOFTWARE, EVEN IF JETBYTE LIMITED 
// HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
//
// This software is not designed or intended for use in on-line control of
// aircraft, air traffic, aircraft navigation or aircraft communications; or in
// the design, construction, operation or maintenance of any nuclear
// facility. Licensee represents and warrants that it will not use or
// redistribute the Software for such purposes.
//
///////////////////////////////////////////////////////////////////////////////

#include "resource.h"    

#include "COMMailslot.h"
#include "IServerMailslotInit.h"

///////////////////////////////////////////////////////////////////////////////
// CServerMailslot
///////////////////////////////////////////////////////////////////////////////
class ATL_NO_VTABLE CServerMailslot : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CServerMailslot, &CLSID_ServerMailslot>,
	public ISupportErrorInfo,
	public IDispatchImpl<IServerMailslot, &IID_IServerMailslot, &LIBID_JBCOMMAILSLOTLib>,
   public IServerMailslotInit,
   private CCOMMailslot
{
public:

   CServerMailslot();
   
DECLARE_REGISTRY_RESOURCEID(IDR_SERVERMAILSLOT)

BEGIN_COM_MAP(CServerMailslot)
	COM_INTERFACE_ENTRY(IServerMailslot)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
   COM_INTERFACE_ENTRY(IServerMailslotInit)
END_COM_MAP()

   // ISupportsErrorInfo

   STDMETHOD(InterfaceSupportsErrorInfo)(
      REFIID riid);

   // IServerMailslot
	
   STDMETHOD(Read)(
      /*[out, retval]*/ VARIANT *ppResults);
	
   STDMETHOD(ReadString)(
      /*[out, retval]*/ BSTR *pResult);
	
   STDMETHOD(get_ReadTimeout)(
      /*[out, retval]*/ long *pVal);
	
   STDMETHOD(put_ReadTimeout)(
      /*[in]*/ long newVal);
	
   STDMETHOD(get_MaxMessageSize)(
      /*[out, retval]*/ long *pVal);
	
   STDMETHOD(get_MessageCount)(
      /*[out, retval]*/ long *pVal);
	
   STDMETHOD(get_MessageWaiting)(
      /*[out, retval]*/ BOOL *pVal);
	
   STDMETHOD(get_SizeOfWaitingMessage)(
      /*[out, retval]*/ long *pVal);

   // IServerMailslotInit

   STDMETHOD(Init)(
      /*[in]*/ BSTR name,
      /*[in]*/ DWORD dwMaxMessageSize,
      /*[in]*/ DWORD dwReadTimeout);
};

#endif // JETBYTE_SERVER_MAILSLOT_INCLUDED_

///////////////////////////////////////////////////////////////////////////////
// End of file
///////////////////////////////////////////////////////////////////////////////


